import config, language, math
from wordclock import ledstrip

length = max(config.LedNumbers) + 1
newDots, oldDots = bytearray([0] * length), bytearray([0] * length)
refresh, last_refresh = 0, -1

def clear_dots():
	global refresh

	for i in range(length): newDots[i], oldDots[i] = 0, newDots[i]
	refresh += 1

def add_dots(line):
	for number in line: newDots[number] = 1

def print_dots(brightness, fade):
	global last_refresh

	# https://en.wikipedia.org/wiki/Weber%E2%80%93Fechner_law
	# https://en.wikipedia.org/wiki/Stevens%27s_power_law
	fadein, fadeout = brightness * math.pow(fade, 2), brightness * math.pow(1 - fade, 2)

	for i in range(length):
		if newDots[i] and oldDots[i]: ledstrip.colorFrame(i, brightness)
		elif newDots[i] and not oldDots[i]: ledstrip.colorFrame(i, fadein)
		elif not newDots[i] and oldDots[i]: ledstrip.colorFrame(i, fadeout)
		else: ledstrip.colorFrame(i, 0)
	ledstrip.write()

	if refresh != last_refresh:
		last_refresh = refresh
		print('\n'.join([''.join(letter if newDots[config.LedNumbers[i*len(row)+j]] else '.' for j, letter in enumerate(row)) for i, row in enumerate(language.frontText)]))
